#ifndef __matrix_h_
#define __matrix_h_

#define MAX_VALUE_LENGTH 15

typedef struct {
  int size;    /* Dimensione in caratteri della stringa (+ carattere \0) */
  char *value; /* Stringa terminata da \0 */
} node;

typedef struct {
  int rank;   /* Rank della riga, corrisponde alla somma delle dimensioni di ogni stringa */
  node *cols; /* Colonne */
} row;

typedef struct {
  int rows; /* Numero di righe */
  int cols; /* Numero di colonne */
  row *m;   /* Puntantore alla matrice */
} matrix;

int matrix_generate(matrix *matrix);
int matrix_populate(matrix *matrix);
void matrix_print(matrix *matrix, const char *title);
void matrix_sort(matrix *matrix);
int matrix_dispose(matrix *matrix);

#endif /* !__matrix_h_ */
